$(document).ready(function(){
	
			scriptloaded();

});

function scriptloaded(){
		$('body').append('<div class="hider"></div>');
		convertUi('body');
}

function convertUi(x){
		$(x+' div').each(function(){
		
		var data = $(this).attr("data-roll");
		if(data!="undefined" && data!=""){
			if(data=="select"){ createSelectBox($(this)); }
			if(data=="radio-group"){ createRadioGroup($(this)); }
			if(data=="switch"){ createSwitch($(this)); }
			if(data=="password"){ createPassword($(this)); }
			if(data=="input"){ createInput($(this)); }
			if(data=="btn"){ createButton($(this)); }
			if(data=="dialog"){ createDialog($(this)); }
			if(data=="div-scrollable"){ createScroll($(this)); }
			if(data=="thumbnail"){ createThumb($(this)); }
			if(data=="thumbnail-group"){ createThumbGroup($(this)); }
			if(data=="range"){ createRange($(this)); }
			if(data=="tab-content"){ createTabs($(this)); }
			if(data=="scroll-table"){ createScrollTable($(this)); }
			if(data=="navbar"){ createNavbar($(this)); }
		}
	});

}

function createNavbar(x){ if(x.attr("fixed")=="false"){ var item = '<div class="navbar">'+x.html()+'</div>'; }else{ var item = '<div class="navbar fixed">'+x.html()+'</div>'; } x.replaceWith(item); }

function slideRight(x,w){
x.css("position","relative");
x.animate({ marginLeft: w },500);
}
function slideLeft(x,w){
x.css("position","relative");
x.animate({ marginRight: w },500);
}
function rightStep(x,w){
	x.css("position","relative");
	var l = x.position().left + w;
	x.animate({ left: l },300);
}

function loadContent(IDS,XURL,OPTIONS){ 
		$(IDS).html('<div style="padding:15px 15px;" class="loader"><strong>Loading Data ...</strong> Please Wait ...</div>');
		$.ajax({ type: "GET", url: XURL, dataType: "html",  data: OPTIONS+"&time="+Math.random(),  
				 success: function(data){ 
					   $(IDS).html(data ); 
						convertUi(IDS);
						  }, 
				 error: function(data){ 
				 	$(IDS).html('<div class="alert alert-error"><strong>Loading failed!</strong><br>File "'+XURL+'" with options "'+OPTIONS+'" not found!</div>');
						
				}					 
		}); 
	}
function getDevice(){
        var _agent = navigator.userAgent;
		var isipad = _agent.search(/iPad.+/);
		var isiphone = _agent.search(/iPhone.+/);
		var isipod = _agent.search(/iPod.+/);
		var isandroid = _agent.search(/Android.+/);
		if(isipad!=-1) { return "iPad"; }
		else if(isiphone!=-1) { return "iPhone"; }
		else if(isipod!=-1) { return "iPod"; }
		else if(isandroid!=-1) { return "Android"; }
		else{
			platform = navigator.platform;
			var ismac = platform.search(/Mac.+/);
			var iswin = platform.search(/Win.+/);
			if(ismac!=-1) { return "Mac Pc"; }
			else if(iswin!=-1) { return "Win Pc"; }
			else{ return "Other device"; }			
		}
}
function getOs(){
	var OSName="Unknown OS";
if (navigator.appVersion.indexOf("Win")!=-1) OSName="Windows";
if (navigator.appVersion.indexOf("Mac")!=-1) OSName="MacOS";
if (navigator.appVersion.indexOf("X11")!=-1) OSName="UNIX";
if (navigator.appVersion.indexOf("Linux")!=-1) OSName="Linux";
	return OSName;
}
function getBrowser(){ 

var nVer = navigator.appVersion;
var nAgt = navigator.userAgent;
var browserName  = navigator.appName;
var fullVersion  = ''+parseFloat(navigator.appVersion); 
var majorVersion = parseInt(navigator.appVersion,10);
var nameOffset,verOffset,ix;

// In Opera, the true version is after "Opera" or after "Version"
if ((verOffset=nAgt.indexOf("Opera"))!=-1) {
 browserName = "Opera";
 fullVersion = nAgt.substring(verOffset+6);
 if ((verOffset=nAgt.indexOf("Version"))!=-1) 
   fullVersion = nAgt.substring(verOffset+8);
}
// In MSIE, the true version is after "MSIE" in userAgent
else if ((verOffset=nAgt.indexOf("MSIE"))!=-1) {
 browserName = "Microsoft Internet Explorer";
 fullVersion = nAgt.substring(verOffset+5);
}
// In Chrome, the true version is after "Chrome" 
else if ((verOffset=nAgt.indexOf("Chrome"))!=-1) {
 browserName = "Chrome";
 fullVersion = nAgt.substring(verOffset+7);
}
// In Safari, the true version is after "Safari" or after "Version" 
else if ((verOffset=nAgt.indexOf("Safari"))!=-1) {
 browserName = "Safari";
 fullVersion = nAgt.substring(verOffset+7);
 if ((verOffset=nAgt.indexOf("Version"))!=-1) 
   fullVersion = nAgt.substring(verOffset+8);
}
// In Firefox, the true version is after "Firefox" 
else if ((verOffset=nAgt.indexOf("Firefox"))!=-1) {
 browserName = "Firefox";
 fullVersion = nAgt.substring(verOffset+8);
}
// In most other browsers, "name/version" is at the end of userAgent 
else if ( (nameOffset=nAgt.lastIndexOf(' ')+1) < 
          (verOffset=nAgt.lastIndexOf('/')) ) 
{
 browserName = nAgt.substring(nameOffset,verOffset);
 fullVersion = nAgt.substring(verOffset+1);
 if (browserName.toLowerCase()==browserName.toUpperCase()) {
  browserName = navigator.appName;
 }
}
// trim the fullVersion string at semicolon/space if present
if ((ix=fullVersion.indexOf(";"))!=-1)
   fullVersion=fullVersion.substring(0,ix);
if ((ix=fullVersion.indexOf(" "))!=-1)
   fullVersion=fullVersion.substring(0,ix);

majorVersion = parseInt(''+fullVersion,10);
if (isNaN(majorVersion)) {
 fullVersion  = ''+parseFloat(navigator.appVersion); 
 majorVersion = parseInt(navigator.appVersion,10);
}

return browserName;

}
function isTouch(){
  return (typeof(window.ontouchstart) != 'undefined') ? true : false;
}
function isTouchDevice(){
	var touch = 'no';
	if(isTouch==true){ touch="yes"; }
	return touch;
}
function isFlashDevice(){
	var flash = "no";
	if(FlashDetect.installed){ flash="yes"; }
	return flash;
}
function flashVersion(){
	if(!FlashDetect.installed){ var version = 'No flash installed'; }
	else{ var version = FlashDetect.raw; }
	return version;
}
function iDevice(){
	var idevice = "no";
	if(isTouch()==true && !FlashDetect.installed && getOs()=="MacOS"){
		idevice = "yes";
	}
	return idevice;
}
function setCookie(a, b, c) {  $.cookie(a, b, {  expires: c }); }
function getCookie(a){ return $.cookie(a); }

function scrollbarWidth() { 
    var scr = null;
    var inn = null;
    var wNoScroll = 0;
    var wScroll = 0;
 
    // Outer scrolling div
    scr = document.createElement('div');
    scr.style.position = 'absolute';
    scr.style.top = '-1000px';
    scr.style.left = '-1000px';
    scr.style.width = '100px';
    scr.style.height = '50px';
    // Start with no scrollbar
    scr.style.overflow = 'hidden';
 
    // Inner content div
    inn = document.createElement('div');
    inn.style.width = '100%';
    inn.style.height = '200px';
 
    // Put the inner div in the scrolling div
    scr.appendChild(inn);
    // Append the scrolling div to the doc
 
    document.body.appendChild(scr);
 
    // Width of the inner div sans scrollbar
    wNoScroll = inn.offsetWidth;
    // Add the scrollbar
    scr.style.overflow = 'auto';
    // Width of the inner div width scrollbar
    wScroll = inn.offsetWidth;
 
    // Remove the scrolling div from the doc
    document.body.removeChild(
    document.body.lastChild);
 
    // Pixel width of the scroller
    return (wNoScroll - wScroll); 
}

var scrota = 1;
function createScrollTable(x){
	var ai = 0;
	var item = '<table class="scroll-table" id="scrota'+scrota+'" cellpadding="0" cellspacing="1" border="0" width="100%">';
	item += '<thead class="top">'
	item += '<tr style="display:block;display: table-header-group;vertical-align: middle;width:100%;">';
		x.find("thead th").each(function(){
			item += '<th>';
			item += '<div>'+$(this).html()+'</div>';
			item += '</th>';
			ai++;
		});
	item += '</tr>';
	item += '</thead>'
	
	item += '<tbody style="display:block;vertical-align:top;height:'+x.attr("height")+'px;overflow-y:scroll;">';
	
	x.find("tbody tr").each(function(){
		item += '<tr>';
			$(this).find("td").each(function(){
				item += '<td><div>'+$(this).html()+'</div></td>';
			});
		item += '</tr>';
	});
		
	item += '</tbody>';
	/*
	item += '<thead class="action" style="height:30px;">';
	item += '<tr style="display:block;display: table-header-group;vertical-align: middle;width:100%;">';
	item += '<th colspan="'+ai+'"><div>Actions</div></th>'
	item += '</tr>';
	item += '</thead>';
	*/
	item += '</table>';
	x.replaceWith(item);
	
	w  = $('#scrota'+scrota).width();
	cw = w/ai;
	$('#scrota'+scrota+' thead.top th').css("width",cw);
	$('#scrota'+scrota+' thead.action th').css("width",w); 
	$('#scrota'+scrota+' tbody td').css("width",cw);
	$('#scrota'+scrota+' tbody tr td:last-child').css("width",(cw-scrollbarWidth()));
	
	scrota++;
}

var tab=1;
function  createTabs(x){
	var item = '<ul class="tabs" id="tabul'+tab+'">';
	var item2 = '';
	var xtab = tab;
	x.find("tab").each(function(){
		var _tab = $(this).attr("rel");
		if(tab==1){ var f = 'class="active"'; h = " active"; var g='';  }else{ var f=''; var g = ' style="display:none;" '; var h = ""; }
		item += '<li tabs="tabul'+xtab+'" alt="tabult'+xtab+'" '+f+' rel="tab'+tab+'">'+_tab+'</li>';
		item2+= '<div class="tabult'+xtab+''+h+' tab_under" '+g+' id="tab'+tab+'">'+$(this).html()+'</div>';
		tab++;
	});
	item += '</ul>';
	
	x.replaceWith(item);
	$('#tabul'+xtab+'').after(item2);
	$('#tabul'+xtab+' li').click(function(){
		var _id = $(this).attr("rel");
		var _alt = $(this).attr("alt");
		var _tabs = $(this).attr("tabs");

		$('.'+_alt+'.active').removeClass("active").hide();
		$('#'+_id).addClass("active").show();
		$('#'+_tabs+' li.active').removeClass("active");
		$(this).addClass("active");
	});
	
}

var ra = 1;
function createRange(x){
	var _name = x.attr("name");
	var _min  = x.attr("min");
 	var _max  = x.attr("max");
 	var _value  = parseInt(x.attr("value"));
	var _size  = x.attr("size");
	var item = '<div class="range-container"><div id="ranr'+ra+'" class="number">'+_value+'</div><div rel="rainp'+ra+'" alt="ranr'+ra+'" style="width:'+_size+'px;" id="slide'+ra+'" class="slider"></div></div><input id="rainp'+ra+'" name="'+_name+'" type="hidden" value="'+_value+'">';
	x.replaceWith(item);
	$( '#slide'+ra ).slider({
		value: _value,
		min: _min,
		max: _max,
		 slide: function(event, ui) {
		 	var a = $(this).attr("alt");
			var b = $(this).attr("rel");
			$('#'+a).html( ui.value );
			$('#'+b).val( ui.value );
		 }
	});
	ra++;
 }

var tng = 1;
var group = 1;
function createThumbGroup(x){
	var item = '';
	var h = x.attr("height");
	allimg = x.find("img");
	
	allimg.each(function(){
		item +='<div class="thumb group" group="gr'+group+'" id="tng'+tng+'"><img style="height:'+h+'px;width:auto;" src="'+$(this).attr("src")+'"></div>';
		
		tng++;
	});
	
	x.replaceWith(item);
	
			$('.thumb.group').hover(
					function(){	$(this).addClass("hover");},
					function(){ $(this).removeClass("hover"); }
			);


			$('.thumb.group').click(
					function(){
						var _all = $('div.thumb.group[group=\''+$(this).attr("group")+'\']').length;
						var _src = $(this).find("img").attr("src");
						var _n = 0;
						var hs = 0;

						$('div.thumb.group[group=\''+$(this).attr("group")+'\']').each(function(){
							if(hs==0 && $(this).find("img").attr("src")!=_src){ _n++; }
							else if(hs==0 && $(this).find("img").attr("src")==_src){ _n++; hs++; }
						});
						
						var item = '<div class="fullimage">';
						
						for(i=1;i<=_all;i++){
							
							if(_n==i){ var c = " active";  }else{ var c=""; }
							var gimg = '';
							var obj = $('div.thumb.group[group=\''+$(this).attr("group")+'\']')[(i-1)];
							var y = obj.innerHTML;
							var z = y.split('src="');
							_source = z[1].split('">');
							gimg = _source[0];
							
							item +='<a onclick="getFullimage(\''+gimg+'\');$(\'.fullimage a\').removeClass(\'active\');$(this).addClass(\'active\');" href="javascript://" style="left:'+(i*24)+'px;top:20px;" class="ggs'+c+'">'+i+'</a>';
						}
						
						item +='<img src="'+_src+'"  onclick="$(\'.fullimage\').fadeOut(500);$(\'.hider\').fadeOut(500);setTimeout(function(){ $(\'.fullimage\').remove(); },700);"></div>';
						$('body').append(item);
												
						setTimeout(function(){
		var w = window.innerWidth;
		var h = window.innerHeight;
		
		var w2 = $('.fullimage').find("img").width();
		var h2 = $('.fullimage').find("img").height();
		if(h2-200<h && w2<w){
			var  ml = w2/2;
			var  mt = h2/2;
			
			ml = ml+2;
			mt = mt+2;
			$('.fullimage').css("margin-left","-"+ml+"px");
			$('.fullimage').css("margin-top","-"+mt+"px");
			$('.fullimage').css("left","50%");
			$('.fullimage').hide()
		}
		else{
			if((w2+200)>w){ 
			
					var abss  = (w2 - w)+200;
			/*
					w2  (w2-abss)
					h2     x
			*/	
			
				var x = ((w2-abss)*h2)/w2;
				w3 = w2 - abss;
				h2 = Math.ceil(x);

				if((h2+100)>h){
					var absh  = (h2 - h)+100;
				/*
					h2  (h2-absh)
					w2     x
				*/
				var x = ((h2-abss)*w2)/h2;
				w2 =  x;
				h2 = h2 - absh;
				
				}
				
				if(w2 > w){ w2 = w3; }
				
			}
			$('.fullimage img').css("width",w2).css("height",h2);

			var  ml = $('.fullimage img').width()/2;
			var  mt = $('.fullimage img').height()/2;
			
			ml = ml+2;
			mt = mt+2;

			$('.fullimage').css("margin-left","-"+ml+"px");
			$('.fullimage').css("margin-top","-"+mt+"px");
			$('.fullimage').css("left","50%");
			$('.fullimage').hide()
		}

			
		
		
		
		$('.hider').fadeIn(500);
		$('.fullimage').fadeIn(500);
		},10);
							
					}
			);			
	
	group++;
	
}

function getFullimage(_src){
	$('.fullimage img').hide();
		$('.fullimage img').attr("src",_src);
	var hio = '<span style="position:absolut; left:-9999px" class="hop"><img src="'+_src+'"></span>';
	$('body').append(hio);
	
	
				setTimeout(function(){
		var w = window.innerWidth;
		var h = window.innerHeight;
		
		var w2 = $('.hop').find("img").width();
		var h2 = $('.hop').find("img").height();
		
		$('.hop').remove();
		if(h2-200<h && w2<w){
			var  ml = w2/2;
			var  mt = h2/2;
			
			ml = ml+2;
			mt = mt+2;
			$('.fullimage img').css("width",w2);
			$('.fullimage img').css("height",h2);
			$('.fullimage').animate({
				width: w2,
				height: h2,
				marginLeft: "-"+ml+"px",
				marginTop: "-"+mt+"px"
			},90);
		}
		else{
			if((w2+200)>w){ 
			
					var abss  = (w2 - w)+200;
			/*
					w2  (w2-abss)
					h2     x
			*/	
			
				var x = ((w2-abss)*h2)/w2;
				w3 = w2 - abss;
				h2 = Math.ceil(x);

				if((h2+100)>h){
					var absh  = (h2 - h)+100;
				/*
					h2  (h2-absh)
					w2     x
				*/
				var x = ((h2-abss)*w2)/h2;
				w2 =  x;
				h2 = h2 - absh;
				
				}
				
				if(w2 > w){ w2 = w3; }
				
			}
			$('.fullimage img').css("width",w2).css("height",h2);

			var  ml = $('.fullimage img').width()/2;
			var  mt = $('.fullimage img').height()/2;
			
			ml = ml+2;
			mt = mt+2;
			$('.fullimage img').css("width",w2);
			$('.fullimage img').css("height",h2);
			$('.fullimage').animate({
				width: w2,
				height: h2,
				marginLeft: "-"+ml+"px",
				marginTop: "-"+mt+"px"
			},90);
		}
	
		},10);	
	
		setTimeout(function(){ $('.fullimage img').fadeIn(200);   },150);
		
}

var tn = 1;
function createThumb(x){
	var _image = x.find("img").attr("src");
	var h = x.attr("height");
	var item = '<div class="thumb" id="thumb'+tn+'"><img style="height:'+h+'px;width:auto;" src="'+_image+'"></div>';
	
	x.replaceWith(item);
	
	$('#thumb'+tn).hover(
		function(){
			$(this).addClass("hover");
		},function(){
			$(this).removeClass("hover");
		}
	);
	$('#thumb'+tn).click(function(){
		var _src = $(this).find("img").attr("src");
		var preview = '<div style="left:-9999px;" class="fullimage" onclick="$(\'.fullimage\').fadeOut(500);$(\'.hider\').fadeOut(500);setTimeout(function(){ $(\'.fullimage\').remove(); },700);"><img src="'+_src+'"></div>';
		$('body').append(preview);
		setTimeout(function(){
		var w = window.innerWidth;
		var h = window.innerHeight;
		
		var w2 = $('.fullimage').find("img").width();
		var h2 = $('.fullimage').find("img").height();
		if(h2<h && w2<w){
			var  ml = w2/2;
			var  mt = h2/2;
			
			ml = ml+2;
			mt = mt+2;
			$('.fullimage').css("margin-left","-"+ml+"px");
			$('.fullimage').css("margin-top","-"+mt+"px");
			$('.fullimage').css("left","50%");
			$('.fullimage').hide()
		}
		else{
			if((w2+200)>w){ 
			
					var abss  = (w2 - w)+200;
			/*
					w2  (w2-abss)
					h2     x
			*/	
			
				var x = ((w2-abss)*h2)/w2;
				w3 = w2 - abss;
				h2 = Math.ceil(x);

				if((h2+100)>h){
					var absh  = (h2 - h)+100;
				/*
					h2  (h2-absh)
					w2     x
				*/
				var x = ((h2-abss)*w2)/h2;
				w2 =  x;
				h2 = h2 - absh;
				
				}
				
				if(w2 > w){ w2 = w3; }
				
			}
			$('.fullimage img').css("width",w2).css("height",h2);

			var  ml = $('.fullimage img').width()/2;
			var  mt = $('.fullimage img').height()/2;
			
			ml = ml+2;
			mt = mt+2;

			$('.fullimage').css("margin-left","-"+ml+"px");
			$('.fullimage').css("margin-top","-"+mt+"px");
			$('.fullimage').css("left","50%");
			$('.fullimage').hide()
		}
	
		$('.hider').fadeIn(500);
		$('.fullimage').fadeIn(500);
		},10);
	});
	tn++;
}

var scroll = 1;
function createScroll(x){
	var _height = x.attr("height");

	var item = '<div class="scroll"><div id="scroll'+scroll+'">'+x.html()+'</div></div>';
	
	x.replaceWith(item);
	if(isTouch()==false){
		$('#scroll'+scroll).slimScroll({ height: _height }); 
	}else{
		$('#scroll'+scroll).css("height",_height).css("overflow-y","auto");
	}
	scroll++;
}

var dia = 1;
function createDialog(x){
	var _name = x.attr("name");
	var _title = x.attr("title");
	var modal=x.attr("modal");
	if(modal && modal!="" && modal!="undefined" && modal=="true"){ var bmodal = ' modal="y" '; var hides='$(\'.hider\').fadeOut(500);'; } else{ var bmodal=' modal="n" '; var hides=''; }
	
	var item ='<div '+bmodal+' style="display:none;" name="'+_name+'" class="dialog '+_name+'"><div class="dialog-title"><div onclick="$(\'div.dialog.'+_name+'\').fadeOut(500);'+hides+'" class="closer">x</div>'+_title+'</div><div class="dialog-content">'+x.html()+'</div></div>';
	
	x.replaceWith(item);
	
}

var btn = 1;
function createButton(x){
	var color=x.attr("color");
	if(color && color!="" && color!="undefined"){ var bclass = " "+color; } else{ var bclass=""; }
	var oclick=x.attr("onclick");
	if(oclick && oclick!="" && oclick!="undefined"){ var boclick = oclick; } else{ var boclick=""; }
	
	var item = '<div onclick="'+boclick+'" id="btn'+btn+'" class="btn'+bclass+'">'+x.html()+'</div>';
	x.replaceWith(item);
	
	$('#btn'+btn).hover(
		function(){ $(this).addClass("hover"); },
		function(){ $(this).removeClass("hover"); }
	);
	
	btn++;
}


var sf  = 1;
function  createSwitch(x){
	var swstart = 1;
	var item = '<div class="switcher" id="switch'+sf+'"><div class="in">';
		var first = x.find("li:first-child");
		var second = x.find("li:last-child");
		
		if(first.hasClass("checked")){
			swstart  = 1;
		}
		else if(second.hasClass("checked")){
			swstart  = 2;
		}
		
		item +='<div alt="'+first.attr("rel")+'" rel="swinp'+sf+'"  class="switch-in '+first.attr('class')+' one">'+first.html()+'</div><div class="middle"></div>';
		item +='<div alt="'+second.attr("rel")+'" rel="swinp'+sf+'" class="switch-in '+second.attr('class')+' two">'+second.html()+'</div>';
	item +='</div></div><input name="'+x.attr("name")+'" type="hidden" id="swinp'+sf+'">';
	
	x.replaceWith(item);
	
	$('#switch'+sf).attr("rel",swstart);
	$('#switch'+sf).click(function(){
		var chk = $(this).attr("rel");
		if(chk==1){
			$(this).find(".in").stop().animate({ marginLeft: '-60px' },300);
			$(this).attr("rel","2");
			var valu = $(this).find(".two").attr("alt");
			 var target = $(this).find(".two").attr("rel");
			$('#'+target).val(valu);
		}
		else{
			$(this).find(".in").stop().animate({ marginLeft: '0px' },300);
			$(this).attr("rel","1");
			var valu = $(this).find(".one").attr("alt");
			 var target = $(this).find(".one").attr("rel");
			$('#'+target).val(valu);
		}
		
	});
	
	if(swstart==1){
		$('#switch'+sf).find(".in").stop().animate({ marginLeft: '0px' },300);
			$('#switch'+sf).attr("rel","1");
			var valu = $('#switch'+sf).find(".one").attr("alt");
			 var target = $('#switch'+sf).find(".one").attr("rel");
			$('#'+target).val(valu);
	}
	else{
	$('#switch'+sf).find(".in").stop().animate({ marginLeft: '-69px' },300);
			$('#switch'+sf).attr("rel","2");
			var valu = $('#switch'+sf).find(".two").attr("alt");
			 var target = $('#switch'+sf).find(".two").attr("rel");
			$('#'+target).val(valu);
	}
	
	sf++;
}

var sb = 1;
function createSelectBox(x){
	var ph = x.attr("placeholder");
	var fw = ph;
	var fw2 = "";
	var item = '<div class="selectbox" id="select-box'+sb+'"><div rel="sbc'+sb+'" class="select-box-chose" id="sbva'+sb+'">...</div></div><div id="sbc'+sb+'" class="select-box-choser"><div id="sbci'+sb+'"><div role="sbva'+sb+'" target="sbif'+sb+'" alt="sbc'+sb+'" class="select-box-option" rel="">'+ph+'</div>';
	
	x.find("li").each(function(){
		if($(this).hasClass("selected")){ fw = $(this).html(); fw2 = $(this).attr("rel"); }
		item += '<div role="sbva'+sb+'" target="sbif'+sb+'" alt="sbc'+sb+'" class="select-box-option" rel="'+$(this).attr("rel")+'">'+$(this).html()+'</div>';
	});
	
	item+='</div></div><input name="'+x.attr("name")+'" type="hidden" id="sbif'+sb+'" value="'+fw2+'">';
	
	x.replaceWith(item);
	
	$('#sbif'+sb+'').val(fw2);
	$('#sbva'+sb).html(fw);
	var scroll = x.attr("scroll");
	if(scroll && scroll!="" && scroll!="undefined" && scroll=="true"){
	
	if(isTouch()==false){
		$('#sbci'+sb).slimScroll({ height:100 }); 
	}else{
		$('#sbci'+sb).css("height",100).css("overflow-y","auto");
	}	
		
	}
	$('#sbc'+sb).hide();
	
	$('#sbc'+sb+' div').hover(
		function(){ $(this).addClass("hover"); },
		function(){ $(this).removeClass("hover"); }
	);
	
	$('#sbc'+sb+' div').click(
		function(){ 
			$('#'+$(this).attr("alt")).fadeOut(500).removeClass("see");
			$('#'+$(this).attr("role")).removeClass("see").html($(this).html());
			$('#'+$(this).attr("target")).val($(this).attr("rel"));
		}
	);
	
	$('#sbva'+sb).click(function(){
		var target = $('#'+$(this).attr("rel"));
		if(target.hasClass("see")){
			target.fadeOut(500).removeClass("see");
			$(this).removeClass("see");
		}
		else{
		
			var l = $(this).position().left;
			target.css("left",l);
			var t = $(this).position().top + 27;
			target.css("top",t);
			target.fadeIn(500).addClass("see");
			$(this).addClass("see");
		}
	});
	
	sb++;
}


var rg = 1;
function createRadioGroup(x){
	var fw = '';
	var item = '<div id="rg'+rg+'" class="radio-group">';
	x.find("li").each(function(){
		var opt = $(this).attr("rel");
		if($(this).hasClass("checked")){ var cl=' checked'; fw = opt; }else{ var cl=''; }
		item+='<div alt="rg'+rg+'" target="rgfi'+rg+'" rel="'+opt+'" class="radio-option'+cl+'">'+$(this).html()+'</div>';
	});
	item+='</div><input name="'+x.attr("name")+'" value="'+fw+'" type="hidden" id="rgfi'+rg+'">';
	x.replaceWith(item);
	
	$('#rg'+rg+' div').click(function(){
			var target = $(this).attr("alt");
			var target2 = $(this).attr("target");
			var opt = $(this).attr("rel");
			$('#'+target+' div.checked').removeClass("checked");
			$(this).addClass("checked");
			$('#'+target2).val(opt);
	});
	
	$('#rg'+rg+' div:first-child').addClass("first");
	$('#rg'+rg+' div:last-child').addClass("last");
	
	rg++;
}


var pw = 1;
function createPassword(x){
	var _name = x.attr("name");
	var _ph = x.attr("placeholder");	
	var size = x.attr("size");
	var item = '<div style="width:'+size+'px;" class="input"><input id="inpw'+pw+'" target="pw'+pw+'" placeholder="'+_ph+'" type="text" name="'+_name+'" value=""></div>';
	x.replaceWith(item);
	
	
	 $('#inpw'+pw).dPassword();
	pw++;
}

var emailReg = /^([\w-\.]+@([\w-]+\.)+[\w-]{2,4})?$/;
var ipw = 1;
function createInput(x){
	var _name = x.attr("name");
	var _ph = x.attr("placeholder");	
	var size = x.attr("size");
	var icompare=x.attr("compare");
	if(icompare && icompare!="" && icompare!="undefined"){
		comp = ' compare="'+icompare+'" ';
	}
	else{ comp=''; }
	var item = '<div style="width:'+size+'px;" id="inpwi'+ipw+'" class="input"><input '+comp+' id="inpw'+ipw+'" target="inpwi'+ipw+'" placeholder="'+_ph+'" type="text" name="'+_name+'" value=""></div>';

	var icheck=x.attr("check");
	x.replaceWith(item);

	if(icheck && icheck!="" && icheck!="undefined" && icheck=="true"){
		$('#inpw'+ipw).bind("blur",function(){
			
			var itest = $(this).val();
			var target = $(this).attr("target");
			if(itest==""){ $('#'+target).addClass("nothing"); }
			else{ $('#'+target).removeClass("nothing"); }
		});
	}
	
	if(icompare && icompare!="" && icompare!="undefined"){
		$('#inpw'+ipw).bind("blur",function(){
			var ttarget = $(this).attr("compare");
			var itest = $(this).val();
			var target = $(this).attr("target");
			
			
			if(itest=="" || itest!=$("input[name='"+ttarget+"']").val()){ $('#'+target).addClass("nothing"); }
			else{ $('#'+target).removeClass("nothing"); }
		});
	}
		
	if(icheck && icheck!="" && icheck!="undefined" && icheck=="email"){
		$('#inpw'+ipw).bind("blur",function(){
			
			var itest = $(this).val();
			var target = $(this).attr("target");
			if(itest=="" || !emailReg.test(itest)){ $('#'+target).addClass("nothing"); }
			else{ $('#'+target).removeClass("nothing"); }
		
			
		});
	}
	ipw++;
}

function Dialog(_name){
	$('.dialog').hide();
	$('.hider').hide();
	
	var w  = $("div.dialog[name='"+_name+"']").width() / 2;
	var h  = $("div.dialog[name='"+_name+"']").height() / 2;
	
	$("div.dialog[name='"+_name+"']").css("margin-left","-"+w+"px");
	$("div.dialog[name='"+_name+"']").css("margin-top","-"+h+"px");
	
	$("div.dialog[name='"+_name+"']").fadeIn(500);
	if($("div.dialog[name='"+_name+"']").attr("modal")=="y"){ $('.hider').fadeIn(400); }
		
}

(function() {
	jQuery.fn.dPassword = function(options) {
		
		// support multiple elements
	    if (this.length > 1) {
	        this.each(function() {jQuery(this).dPassword(options);});
	        return this;
	    }
    
		var options = jQuery.extend(defaultOptions, options);
		options.cloakingCharacter = options.cloakingCharacter.charAt(0);
	
		var _input = $(this);
		var _value = null,
			_previousInputValue = null,
			_timeout = null,
			_previousSelection = null,
			_options = null,
			_observing = false,
			_form = null,
			_toggleIcon = null,
			_keysDown = {},
			_inputFieldTypes = {};
			
		// register event listeners
		registerHandlers(_input);
		if (options.observeForm || options.form) {
			if (!_form) _form = options.form ? $(options.form) : _input.closest('form');
			if (_form) _form.bind("submit.dPassword", function(){deactivate(true);});
		}

		// create/handle toggle icon
		if (options.showIcon) {
			_toggleIcon = jQuery("<div class='dpassword-lock'></div>").insertAfter(_input);
			_toggleIcon.css({backgroundImage: "url(" + (options.iconPath || options.ICON_PATH) + ")"});
			_toggleIcon.css(options.ICON_STYLES);
			_toggleIcon.bind("click", function() {
				_observing ? deactivate() : activate();
				_input.focus();
			});
		}

		// TODO: public methods
		// TODO: possible to overwrite val() to outside?
	
 		activate();
		return this;
		
		// ------- method declarations follow ----------
	
		/**
		 * Returns the current value of the password field.
		 */
		function getValue() {
			return _observing ? _value : _input.val();
		}
	
		/**
		 * Switches to active mode. Will be automatically called on initialization.
		 * Use getValue() to retrieve field value once activated.
		 */
		function activate() {
			_observing = true;
			_value = _input.val();
			_cloakInput();
			if (_toggleIcon) _switchToggleIcon(true);
			if (options.onStateChange) options.onStateChange(_observing, this, _toggleIcon);
		}

		/**
		 * Deactivates dPassword temporarily/permanently and switches field back to normal password behaviour
		 * to e.g. perform DOM operations or value retrieval.
		 * IMPORTANT: If "temporarily" parameter is set to true will auto-reactivates on any input.
		 */
		function deactivate(temporarily) {
			if (_observing) {
				if (_timeout) {
					clearTimeout(_timeout);
					_timeout = null;
				}
				var selection = _getFieldSelection(_input);
				jQuery.browser.msie ? _switchInputTypeIE("password") : _input.get(0).setAttribute("type", "password");	// override jQuery's behaviour
				_input.val(getValue());
				if (document.activeElement && document.activeElement == _input) _setFieldSelection(_input, selection);
				if (temporarily !== true) {
					_observing = false;
					if (_toggleIcon) _switchToggleIcon(false);
					if (options.onStateChange) options.onStateChange(_observing, this, _toggleIcon);
				}
			}
		}

		function _keyDownHandler(event) {
			if (_observing) {
				if (!(_isSpecialKey(event.keyCode) || event.metaKey || event.ctrlKey)) {
					var keyCode = null;
					for (var keyCode in _keysDown) {
						_afterInputHandler(keyCode);
					}
					_storeSelection();
					if (!keyCode) _cloakInput();
					if (event.keyCode > 10) _keysDown[event.keyCode] = true;
				} else {
					_storeSelection();
					if (_timeout) {
						clearTimeout(_timeout);
						_timeout = null;
						_cloakInput();
					}
				}
			}
		}
	
		function _keyUpHandler(event) {
			if (_observing) {
				if (event.type == "paste") {
					setTimeout(_afterInputHandler, 0);
					return;
				}
		    	if (_isSpecialKey(event.keyCode) || event.metaKey || event.ctrlKey) return;
				if (_keysDown[event.keyCode] || event.keyCode < 11) _afterInputHandler(event);
			} else {
				var value = _input.val();
				if (value != _previousInputValue) {
					_previousInputValue = value;
					if (options.onChange) options.onChange(getValue());
				}
			}
		}

		function _afterInputHandler(keyCode) {
			delete _keysDown[keyCode];
			var value = _input.val();
			var selection = _getFieldSelection(_input);

			if (_previousInputValue != value) {
				var sStart = _previousSelection[0],
					sEnd = _previousSelection[1],
					sLength = _previousSelection[2],
					lengthDifference = value.length - _value.length,	// > 0: characters added
					newValue;			
				if (lengthDifference < 0 && sLength == 0) {		// single character deletion
					if (sStart == selection[0])	{				// forward deletion
						newValue = _value.substring(0, sStart) + _value.substring(sEnd + 1);
					} else {									// has to be backward deletion
						newValue = _value.substring(0, selection[0]) + _value.substring(sEnd);
					}
				} else {										// a selection has been replaced/deleted
					newValue = _value.substring(0, sStart) + value.substring(sStart, selection[1]) + _value.substring(sEnd);
				}
				_value = newValue;
				if (options.onChange) options.onChange(getValue());

				if (_timeout) {
					clearTimeout(_timeout);
					_timeout = null;
				}

				if (lengthDifference >= 0) {
					// leave newly written part uncloaked
					_cloakInput([sStart + 1, selection[1]]);
					_timeout = setTimeout(_cloakInput, options.delay * 1000);
				}
			} else {
				_previousSelection = selection;
			}
		}
				
		function registerHandlers(element) {
			element.bind("keydown.dPassword", _keyDownHandler);
			element.bind("keyup.dPassword paste.dPassword", _keyUpHandler);
			element.bind("select.dPassword focus.dPassword", _storeSelection);
			if (options.switchToPasswordType) {
				_input.bind("blur.dPassword", function() {deactivate(true);});		
			}	
		}
	
		function _storeSelection() {
			if (_observing)	_previousSelection = _getFieldSelection(_input);
		}
	
		function _cloakInput(keepRange) {
			var selection = _getFieldSelection(_input);
			var value = _input.val();
			if (keepRange) {
				_input.val(value.substring(0, keepRange[0] - 1 ).replace(/./g, options.cloakingCharacter) + value.substring(keepRange[0] - 1, keepRange[1]) + value.substring(keepRange[1]).replace(/./g, options.cloakingCharacter));
			} else {
				_input.val(value.replace(/./g, options.cloakingCharacter));
				if (_input.attr("type") != "text") {
					if (jQuery.browser.msie) {
						_switchInputTypeIE("text");
					} else {
						_input.get(0).setAttribute("type", "text");	// override jQuery's behaviour
					}
					_input.attr("autocomplete", "off");
				}
			}
			if (document.activeElement && document.activeElement == _input.get(0)) _setFieldSelection(_input, selection);
			_previousInputValue = _input.val();
		}	

		function _switchInputTypeIE(toType) {
			// create input field (or retrieve from cache) with new type
			var newInput = _inputFieldTypes[toType];
			if (!newInput) {
				var tempDiv = _input.clone().wrap('<div></div>').parent();
				if (toType == "password") {
					tempDiv.html(tempDiv.html().replace(/>/, 'type="password">'));
				} else {
					tempDiv.html(tempDiv.html().replace(/type="?password"?/, 'type="text"'));
				}
				newInput = tempDiv.children();
				registerHandlers(newInput);
			}
			
			// update field
			newInput.css('width', (_input.get(0).clientWidth - 2*parseInt(_input.get(0).currentStyle.padding, 10)) + "px");
			newInput.css('height', (_input.get(0).clientHeight - 2*parseInt(_input.get(0).currentStyle.padding, 10)) + "px"); // fix different widths for password and text inputs in IE
			var oldInput = _input;
			oldInput.get(0).replaceNode(newInput.get(0));	// jQuery's replaceWith method gobbles the event handlers, apparently.
			_input = newInput;
			_input.val(oldInput.val());

			// first time here: store elements in cache
			if (!_inputFieldTypes) {
				_inputFieldTypes = {
					password: (toType == "password") ? newInput : oldInput,
					text: (toType == "password") ? oldInput : newInput
				};
			}
		}

		function _switchToggleIcon(state) {
			if (state) {
				_toggleIcon.css(options.ICON_STYLES_OFF).css({className: "dpassword-lock-closed"});
				_toggleIcon.attr('title', options.ICON_TITLE_ON);
			} else {
				_toggleIcon.css(options.ICON_STYLES_ON).css({className: "dpassword-lock-closed"});
				_toggleIcon.attr('title', options.ICON_TITLE_OFF);
			}
		}
	};
	
	var defaultOptions = {
		delay: 1,
		observeForm: true,					 
		form: null,							 
		cloakingCharacter: (navigator.platform == "MacIntel") ? '\u2022' : '\u25CF',		 
		onChange: null,
		onStateChange: null,
		showIcon: true,
		switchToPasswordType: !jQuery.browser.msie,		
		/*
		 * Default styles and behaviours for lock icon, see showIcon option.
		 * Override at will.
		 */
		ICON_TITLE_ON: "Delayed masking active, click here to switch off.",
		ICON_TITLE_OFF: "Click to activate delayed masking of input.",
		ICON_STYLES: {
			display: "inline",
			position: "absolute",
			width: "16px", height: "16px",
			margin: "-10px 0 0 -12px",
			overflow: "text", cursor: "pointer",
			backgroundRepeat: "no-repeat"
		},
		ICON_PATH: "lock.gif",		// set to your position of icon
		ICON_STYLES_OFF: {
			backgroundPosition: "0 0"
		},
		ICON_STYLES_ON: {
			backgroundPosition: "0 -16px"
		}
	};
	
	function _getFieldSelection(element) {
		if (document.selection) {
			var range = document.selection.createRange();
			var length = range.text.length;
			range.moveStart('character', -element.val().length);	// Move selection start to 0 position
			var cursorPos = range.text.length;	// The caret position is now the selection length
			return [cursorPos - length, cursorPos, length];
		} else {
			var el = element.get(0);
			return [el.selectionStart, el.selectionEnd, el.selectionEnd - el.selectionStart];
		}
	}
	
	function _setFieldSelection(element, selection) {
		var el = element.get(0);
		if (document.selection) {
			var range = el.createTextRange();
			range.collapse();
			range.moveStart('character', selection[0]);
			range.moveEnd('character', selection[1] - selection[0]);
			range.select();
		} else {
			el.selectionStart = selection[0];
			el.selectionEnd = selection[1];
		}
	}
	
	function _isSpecialKey(keyCode) {
		// TODO: Need to check OS? Windows key?
		return (keyCode >= 9 && keyCode <= 20) || (keyCode >= 33 && keyCode <= 40) || keyCode == 224;
	}
})();